CFG.masks = {
	cleaver = {
		name = L.mask_cleaver,
		mdl = 'models/props_lab/Cleaver.mdl',
		pos = Vector(-3.1, 6.7, 5.2),
		ang = Angle(0, 85, 0),
		scale = 0.6,
	},
	monkey = {
		name = L.mask_monkey,
		mdl = 'models/sal/halloween/monkey.mdl',
		pos = Vector(-4.1, 0, -2.2),
		hideName = true,
	},
	zombie = {
		name = L.mask_zombie,
		mdl = 'models/sal/halloween/zombie.mdl',
		pos = Vector(-3.7, 0, -2),
		hideName = true,
	},
	hockey = {
		name = L.mask_hockey,
		mdl = 'models/sal/acc/fix/mask_2.mdl',
		pos = Vector(-4, 0, -1.9),
		hideName = true,
	},
	gingerbread = {
		name = L.mask_gingerbread,
		mdl = 'models/sal/gingerbread.mdl',
		pos = Vector(-4.2, 0, -2),
		ang = Angle(-2.8, 0, 0),
		hideName = true,
	},
	pumpkin = {
		name = L.mask_pumpkin,
		mdl = 'models/halloween2015/pumbkin_n_f01.mdl',
		pos = Vector(-2.9, 0, 0.7),
		ang = Angle(11, 0, 0),
		scale = 0.4,
		hideName = true,
	},
	top_hat = {
		name = L.mask_top_hat,
		mdl = 'models/player/items/humans/top_hat.mdl',
		pos = Vector(-3.1, 0, -3.6),
	},
	doctor = {
		name = L.mask_doctor,
		mdl = 'models/sal/halloween/doctor.mdl',
		pos = Vector(-5, 0, -2),
		hideName = true,
	},
	pig = {
		name = L.mask_pig,
		mdl = 'models/sal/pig.mdl',
		pos = Vector(-4.2, 0, -2.4),
		hideName = true,
	},
	bear = {
		name = L.mask_bear,
		mdl = 'models/sal/bear.mdl',
		pos = Vector(-4.3, 0, -1.7),
		ang = Angle(-5.6, 0, 0),
		hideName = true,
	},
	turtle = {
		name = L.mask_turtle,
		mdl = 'models/props/de_tides/vending_turtle.mdl',
		pos = Vector(-3.2, 0.1, 3.8),
		ang = Angle(-1.3, -95.9, -3.8),
		scale = 0.61,
	},
	deer = {
		name = L.mask_deer,
		mdl = 'models/monstermash/gibs/head_deerhaunter.mdl',
		pos = Vector(-5.1, 0, -6.6),
		ang = Angle(-3.4, 1.5, -2.9),
		scale = 1.3,
		skin = 1,
		hideName = true,
	},
	mummy = {
		name = L.mask_mummy,
		mdl = 'models/monstermash/gibs/head_mummy.mdl',
		pos = Vector(0, 0, -7),
		ang = Angle(0, 95.1, -18.6),
		scale = 1.02,
		hideName = true,
	},
	santa = {
		name = 'Новогодний колпак',
		icon = 'octoteam/icons/xmas_hat.png',
		mdl = 'models/cloud/kn_santahat.mdl',
		pos = Vector(-4.6, 0, -3.8),
		ang = Angle(0.8, -85.2, 81.1),
		scale = 1.02,
	},
	gasmask = {
		name = L.mask_gasmask,
		icon = 'octoteam/icons/gasmask.png',
		desc = L.desc_gasmask,
		mdl = 'models/splinks/kf2/cosmetics/gas_mask.mdl',
		pos = Vector(-4.4, 0, -2.7),
		ang = Angle(0, 0, 0),
		hideName = true,
	},

	cap_dobrograd = {
		name = L.cap_dobrograd,
		icon = 'octoteam/icons/clothes_cap.png',
		desc = L.cap_dobrograd_desc,
		noDrop = true,
		mdl = 'models/modified/hat08.mdl',
		pos = Vector(-3.7, 0, 1.1),
		skin = 1,
	},
	orangecap = {
		name = 'Оранжевая кепка',
		icon = 'octoteam/icons/clothes_cap.png',
		desc = 'Обычная оранжевая кепка с каким-то логотипом',
		mdl = 'models/modified/hat08.mdl',
		pos = Vector(-3.7, 0, 1.1),
		skin = 0,
		price = 12000,
	},
	redcap = {
		name = 'Красная кепка',
		icon = 'octoteam/icons/clothes_cap.png',
		desc = 'Классическая красная кепка с каким-то логотипом',
		mdl = 'models/modified/hat08.mdl',
		pos = Vector(-3.7, 0, 1.1),
		skin = 4,
		price = 14000,
	},
	cap_meteorite = {
		name = 'Кепка "Meteorite"',
		icon = 'octoteam/icons/clothes_cap.png',
		desc = 'Классическая кепка черного цвета с логотипом "Meteorite"',
		mdl = 'models/modified/hat08.mdl',
		pos = Vector(-3.7, 0, 1.1),
		skin = 8,
		price = 12000,
	},
	cap_monkey = {
		name = 'Кепка "Orang-O-Tang"',
		icon = 'octoteam/icons/clothes_cap.png',
		desc = 'Классическая кепка коричневого цвета с логотипом "Orang-O-Tang" и обезьянкой',
		mdl = 'models/modified/hat08.mdl',
		pos = Vector(-3.7, 0, 1.1),
		skin = 11,
		price = 14000,
	},
	cap_quests = {
		name = 'Кепка "Лига Квестов"',
		icon = 'octoteam/icons/clothes_cap.png',
		desc = 'Фирменная кепка Лиги Квестов',
		mdl = 'models/leeetov/quest_cap.mdl',
		pos = Vector(-3.6, -0.19, 1.8),
	},

	mask_hoffman = {
		name = 'Маска с эмблемой короны',
		desc = L.mask_hoffman,
		noDrop = true,
		mdl = 'models/sal/acc/fix/mask_2.mdl',
		pos = Vector(-3.8, 0, -1.9),
		ang = Angle(0, 0, 0),
		skin = 5,
		hideName = true,
	},
	hoff_widesmile = {
		name = 'Пакет на голову',
		desc = '"Звериный скал"',
		noDrop = true,
		mdl = 'models/sal/halloween/bag.mdl',
		pos = Vector(-3.3, 0, -1.5),
		ang = Angle(0, 0, 0),
		skin = 1,
		hideName = true,
	},
	hoff_tears = {
		name = 'Пакет на голову',
		desc = '"Плак-плак"',
		noDrop = true,
		mdl = 'models/sal/halloween/bag.mdl',
		pos = Vector(-3.3, 0, -1.5),
		ang = Angle(0, 0, 0),
		skin = 2,
		hideName = true,
	},
	hoff_tinysmile = {
		name = 'Пакет на голову',
		desc = '"Легкий скал"',
		noDrop = true,
		mdl = 'models/sal/halloween/bag.mdl',
		pos = Vector(-3.3, 0, -1.5),
		ang = Angle(0, 0, 0),
		skin = 3,
		hideName = true,
	},
	hoff_dude = {
		name = 'Пакет на голову',
		desc = '"Чувак"',
		noDrop = true,
		mdl = 'models/sal/halloween/bag.mdl',
		pos = Vector(-3.3, 0, -1.5),
		ang = Angle(0, 0, 0),
		skin = 5,
		hideName = true,
	},
	hoff_killme = {
		name = 'Пакет на голову',
		desc = '"Пожалуйста, убейте"',
		noDrop = true,
		mdl = 'models/sal/halloween/bag.mdl',
		pos = Vector(-3.3, 0, -1.5),
		ang = Angle(0, 0, 0),
		skin = 8,
		hideName = true,
	},
	hoff_helpme = {
		name = 'Пакет на голову',
		desc = '"Помогите"',
		noDrop = true,
		mdl = 'models/sal/halloween/bag.mdl',
		pos = Vector(-3.3, 0, -1.5),
		ang = Angle(0, 0, 0),
		skin = 18,
		hideName = true,
	},
	hardhat = {
		name = 'Строительная каска',
		noDrop = true,
		mdl = 'models/props_junk/hardhat.mdl',
		pos = Vector(-3.5, 0, 1.2),
		ang = Angle(-5, 0, 0),
		scale = 0.73,
	},
	peakless = {
		name = 'Бескозырка',
		desc = 'Удобная бескозырка, только без острия',
		icon = 'octoteam/icons/peaky_hat.png',
		mdl = 'models/modified/hat06.mdl',
		pos = Vector(-4.5, -0.2, 2.2),
		ang = Angle(0, 4.1, 0),
		scale = 1.01,
		price = 34000,
	},
	ninja = {
		name = 'Балаклава',
		desc = 'Маска, закрывающая не только лицо, но и часть головы и шею',
		icon = 'octoteam/icons/robber.png',
		mdl = 'models/sal/halloween/ninja.mdl',
		pos = Vector(-4.2, 0.21, -2),
		scale = 1.042,
		hideName = true,
	},
	balaclava = {
		name = 'Черная балаклава',
		desc = 'Маска, закрывающая не только лицо, но и часть головы и шею',
		icon = 'octoteam/icons/robber.png',
		mdl = 'models/modified/balaclava.mdl',
		pos = Vector(-3.8, 0.0, 1),
		price = 10000,
		hideName = true,
	},
	balaclava_g = {
		name = 'Зеленая балаклава',
		desc = 'Маска, закрывающая не только лицо, но и часть головы и шею',
		icon = 'octoteam/icons/robber.png',
		mdl = 'models/modified/balaclava_g.mdl',
		pos = Vector(-2.3, 0.0, 2.2),
		price = 10000,
		hideName = true,
	},

	baseball = {
		name = 'Классическая бейсболка',
		desc = 'Бейсболка с логотипом лиги бейсбола',
		icon = 'octoteam/icons/clothes_cap.png',
		mdl = 'models/modified/hat07.mdl',
		pos = Vector(-4, -0.19, 1.8),
		ang = Angle(-7.2, 0, 0),
		skin = 10,
		price = 19000,
	},
	baseball_jordan = {
		name = 'Бейсболка Jordan',
		desc = 'Черная бейсболка с характерной баскетбольной символикой',
		icon = 'octoteam/icons/clothes_cap.png',
		mdl = 'models/modified/hat07.mdl',
		pos = Vector(-4, -0.19, 1.8),
		ang = Angle(-7.2, 0, 0),
		skin = 0,
		price = 20000,
	},
	yellowbaseball = {
		name = 'Желтая бейсболка',
		desc = 'Бейсболка желтого цвета с вышитой надписью',
		icon = 'octoteam/icons/clothes_cap.png',
		mdl = 'models/modified/hat07.mdl',
		pos = Vector(-4, -0.19, 1.8),
		ang = Angle(-7.2, 0, 0),
		skin = 1,
		price = 15000,
	},
	baseball_stetson = {
		name = 'Бейсболка Stetson',
		desc = 'Бейсболка в классическом американском стиле',
		icon = 'octoteam/icons/clothes_cap.png',
		mdl = 'models/modified/hat07.mdl',
		pos = Vector(-4, -0.19, 1.8),
		ang = Angle(-7.2, 0, 0),
		skin = 3,
		price = 24000,
	},
	baseball_detroit = {
		name = 'Бейсболка Detroit',
		desc = 'Классическая бейсболка темно-синего цвета с вышитым на передней части логотипом города',
		icon = 'octoteam/icons/clothes_cap.png',
		mdl = 'models/modified/hat07.mdl',
		pos = Vector(-4, -0.19, 1.8),
		ang = Angle(-7.2, 0, 0),
		skin = 6,
		price = 18000,
	},

	bandana = {
		name = 'Черная бандана',
		desc = 'Небольшой кусок ткани, служащий для сокрытия лица',
		icon = 'octoteam/icons/bandana.png',
		mdl = 'models/octoteam/accessory/bandana.mdl',
		pos = Vector(-3.95, 0.1, -4),
		ang = Angle(0.2, 0, 0),
		scale = 1.03,
		skin = 5,
		price = 5000,
		hideName = true,
	},
	redbandana = {
		name = 'Красная бандана',
		desc = 'Небольшой кусок ткани, служащий для сокрытия лица',
		icon = 'octoteam/icons/bandana.png',
		mdl = 'models/octoteam/accessory/bandana.mdl',
		pos = Vector(-3.95, 0.1, -4),
		ang = Angle(0.2, 0, 0),
		scale = 1.03,
		skin = 1,
		price = 5000,
		hideName = true,
	},
	yellowbandana = {
		name = 'Желтая бандана',
		desc = 'Небольшой кусок ткани, служащий для сокрытия лица',
		icon = 'octoteam/icons/bandana.png',
		mdl = 'models/octoteam/accessory/bandana.mdl',
		pos = Vector(-3.95, 0.1, -4),
		ang = Angle(0.2, 0, 0),
		scale = 1.03,
		skin = 2,
		price = 5000,
		hideName = true,
	},
	greenbandana = {
		name = 'Зеленая бандана',
		desc = 'Небольшой кусок ткани, служащий для сокрытия лица',
		icon = 'octoteam/icons/bandana.png',
		mdl = 'models/octoteam/accessory/bandana.mdl',
		pos = Vector(-3.95, 0.1, -4),
		ang = Angle(0.2, 0, 0),
		scale = 1.03,
		skin = 3,
		price = 5000,
		hideName = true,
	},
	bluebandana = {
		name = 'Синяя бандана',
		desc = 'Небольшой кусок ткани, служащий для сокрытия лица',
		icon = 'octoteam/icons/bandana.png',
		mdl = 'models/octoteam/accessory/bandana.mdl',
		pos = Vector(-3.95, 0.1, -4),
		ang = Angle(0.2, 0, 0),
		scale = 1.03,
		skin = 4,
		price = 5000,
		hideName = true,
	},
	medical_mask = {
		name = 'Медицинская маска',
		desc = 'Сейчас это актуально как никогда',
		icon = 'octoteam/icons/medical_mask.png',
		mdl = 'models/dean/gtaiv/mask.mdl',
		pos = Vector(-3.5, 0, -3.1),
		ang = Angle(11.2, 0, 0),
		scale = 1.01,
		hideName = true,
	},

	blackglasses = {
		name = 'Черные очки',
		desc = 'Самые стандартные очки с дешевой черной оправой',
		icon = 'octoteam/icons/glasses_classic.png',
		mdl = 'models/modified/glasses02.mdl',
		pos = Vector(-3.9, 0, -0.13),
		skin = 3,
		price = 7000,
	},
	glasses = {
		name = 'Классические очки',
		desc = 'Самые стандартные очки с дешевой оправой',
		icon = 'octoteam/icons/glasses_classic.png',
		mdl = 'models/modified/glasses02.mdl',
		pos = Vector(-3.9, 0, -0.13),
		skin = 0,
		price = 7000,
	},
	redglasses = {
		name = 'Красные очки',
		desc = 'Самые стандартные очки с дешевой красной оправой',
		icon = 'octoteam/icons/glasses_classic.png',
		mdl = 'models/modified/glasses02.mdl',
		pos = Vector(-3.9, 0, -0.13),
		skin = 1,
		price = 7000,
	},
	whiteglasses = {
		name = 'Белые очки',
		desc = 'Самые стандартные очки с дешевой белой оправой',
		icon = 'octoteam/icons/glasses_classic.png',
		mdl = 'models/modified/glasses02.mdl',
		pos = Vector(-3.9, 0, -0.13),
		skin = 2,
		price = 7000,
	},
	brownglasses = {
		name = 'Коричневые очки',
		desc = 'Самые стандартные очки с дешевой коричневой оправой',
		icon = 'octoteam/icons/glasses_classic.png',
		mdl = 'models/modified/glasses02.mdl',
		pos = Vector(-3.9, 0, -0.13),
		skin = 4,
		price = 7000,
	},

	modelli = {
		name = 'Очки LQB "Modelli"',
		desc = 'Фирменные очки LQB, позолоченные дужки которых выполнены в виде специального узора',
		icon = 'octoteam/icons/sun_glasses.png',
		mdl = 'models/modified/lqb_glass2.mdl',
		pos = Vector(-3.9, 0, -0.13),
	},
	rettelinee = {
		name = 'Очки Gucci "Rette Linee"',
		desc = 'Очки Gucci с фирменным узором на дужках',
		icon = 'octoteam/icons/glasses_aviator.png',
		mdl = 'models/modified/lqb_glass1.mdl',
		pos = Vector(-3.9, 0, -0.13),
	},

	aviator = {
		name = 'Черные авиаторы',
		desc = 'Стильные очки "капельки" черного цвета, имеющие достаточно удобную форму оправы и линз',
		icon = 'octoteam/icons/glasses_aviator.png',
		mdl = 'models/modified/glasses01.mdl',
		pos = Vector(-4.35, 0, -0.1),
		skin = 0,
		price = 12000,
	},
	greenaviator = {
		name = 'Зеленые авиаторы',
		desc = 'Стильные очки "капельки" зеленого цвета, имеющие достаточно удобную форму оправы и линз',
		icon = 'octoteam/icons/glasses_aviator.png',
		mdl = 'models/modified/glasses01.mdl',
		pos = Vector(-4.35, 0, -0.1),
		skin = 2,
		price = 12000,
	},
	brownaviator = {
		name = 'Коричневые авиаторы',
		desc = 'Стильные очки "капельки" коричневого цвета, имеющие достаточно удобную форму оправы и линз',
		icon = 'octoteam/icons/glasses_aviator.png',
		mdl = 'models/modified/glasses01.mdl',
		pos = Vector(-4.35, 0, -0.1),
		skin = 3,
		price = 12000,
	},
	orangeaviator = {
		name = 'Оранжевые авиаторы',
		desc = 'Стильные очки "капельки" оранжевого цвета, имеющие достаточно удобную форму оправы и линз',
		icon = 'octoteam/icons/glasses_aviator.png',
		mdl = 'models/modified/glasses01.mdl',
		pos = Vector(-4.35, 0, -0.1),
		skin = 4,
		price = 12000,
	},
	greyaviator = {
		name = 'Серые авиаторы',
		desc = 'Стильные очки "капельки" серого цвета, имеющие достаточно удобную форму оправы и линз',
		icon = 'octoteam/icons/glasses_aviator.png',
		mdl = 'models/modified/glasses01.mdl',
		pos = Vector(-4.35, 0, -0.1),
		skin = 5,
		price = 12000,
	},
	greyfedora = {
		name = 'Серая федора',
		desc = 'Легкая шляпка серого цвета, обвитая лентой',
		icon = 'octoteam/icons/detective_hat.png',
		mdl = 'models/modified/hat01_fix.mdl',
		pos = Vector(-4.1, 0, 1.8),
		ang = Angle(0, 0, 0),
		scale = 0.96,
		skin = 0,
		price = 46000,
	},
	fedora = {
		name = 'Черная федора',
		desc = 'Легкая шляпка черного цвета, обвитая лентой',
		icon = 'octoteam/icons/detective_hat.png',
		mdl = 'models/modified/hat01_fix.mdl',
		pos = Vector(-4.1, 0, 1.8),
		ang = Angle(0, 0, 0),
		scale = 0.96,
		skin = 1,
		price = 46000,
	},
	whitefedora = {
		name = 'Белая федора',
		desc = 'Легкая шляпка белого цвета, обвитая лентой',
		icon = 'octoteam/icons/detective_hat.png',
		mdl = 'models/modified/hat01_fix.mdl',
		pos = Vector(-4.1, 0, 1.8),
		ang = Angle(0, 0, 0),
		scale = 0.96,
		skin = 2,
		price = 46000,
	},
	beigefedora = {
		name = 'Бежевая федора',
		desc = 'Легкая шляпка бежевого цвета, обвитая лентой',
		icon = 'octoteam/icons/detective_hat.png',
		mdl = 'models/modified/hat01_fix.mdl',
		pos = Vector(-4.1, 0, 1.8),
		ang = Angle(0, 0, 0),
		scale = 0.96,
		skin = 3,
		price = 46000,
	},
	smartglasses = {
		name = 'R&C SmartGlasses',
		desc = 'Умные очки от компании R&C, выполненные из алюминия черного цвета. На боковой панельке очков есть сенсорная панель управления. На правой линзе выведено изображение с доступом к приложениям',
		icon = octolib.icons.color('rc_glasses'),
		mdl = 'models/rnc/acessories/rnc_smart_glasses01.mdl',
		pos = Vector(-2.6, 0.1, -0.2),
		ang = Angle(0, 0, 0),
		scale = 0.92,
	},
}
